import sha,random,md5

def HH(some): return md5.new(some).hexdigest()
def H(some): return md5.new(some).digest()
def C(some): return ':'.join(some)

class SASL_DIGEST_MD5:
    mechanism = 'DIGEST-MD5'
    nc = 0
    nonce = None
    authzid = None

    def UpdateNonce(self):
        self.nc = self.nc + 1
        nonce=''
        for i in range(7):
            nonce+=hex(int(random.random()*65536*4096))[2:]
        self.nonce = nonce

    def AuthHandler(self,session,sasl,data):

        chal={}
        if data:
            for pair in data.split(','):
                if pair.find('=')==-1:
                    session.sasl['otherdata']=pair
                    continue
                key,value=pair.split('=',1)
                if value[:1]=='"' and value[-1:]=='"': value=value[1:-1]
                if key in ['qop','username','realm','nonce','cnonce','digest-uri',
                           'nc','response','charset','rspauth','algorithm']:
                    chal[key]=value

        if self.nc == 0:
            self.UpdateNonce()
            resp={}
            resp['realm']=session.ourname
            resp['nonce']=self.nonce
            resp['charset']='utf-8'
            resp['qop']='auth'
            resp['algorithm']='md5-sess'
            sasl_data=''
            for key in ['charset','realm','nonce','qop','algorithm']:
                if key in ['algorithm','charset']: sasl_data+="%s=%s,"%(key,resp[key])
                else: sasl_data+='%s="%s",'%(key,resp[key])
            return 'challenge', None, sasl_data[:-1]
        elif self.nc == 1:
            authzid = '%s@%s' % (chal['username'], chal['realm'])
            if "%08X"%self.nc != chal['nc']:
                sasl.DEBUG('nc mismatch','error')
                return 'fail', authzid, 'not-authorized'
            if self.nonce != chal['nonce']:
                sasl.DEBUG('nonce mismatch','error')
                return 'fail', authzid, 'not-authorized'
            resp={}

            password = sasl._owner.AUTH.getpassword(chal['username'], chal['realm'])
            A1=C([H(C([chal['username'],chal['realm'],password])),chal['nonce'],chal['cnonce']])
            A2=C(['AUTHENTICATE',chal['digest-uri']])
            expectedresponse = HH(C([HH(A1),chal['nonce'],chal['nc'],chal['cnonce'],chal['qop'],HH(A2)]))

            if expectedresponse != chal['response']:
                sasl.DEBUG('response mismatch','error')
                return 'fail', authzid, 'not-authorized'

            self.UpdateNonce()
            self.authzid = authzid
            A2=C(['',chal['digest-uri']])
            rspauth = HH(C([HH(A1),chal['nonce'],chal['nc'],chal['cnonce'],chal['qop'],HH(A2)]))
            return 'challenge', authzid, 'rspauth=%s'%rspauth
        elif self.nc == 2:
            return 'success', self.authzid, None
