import sspi
import sspicon

class SASL_GSSAPI:
    mechanism = 'GSSAPI'
    package = 'Kerberos'

    def __init__(self):
        self.sa = sspi.ServerAuth(self.package,scflags=\
            sspicon.ASC_REQ_INTEGRITY|sspicon.ASC_REQ_SEQUENCE_DETECT|\
            sspicon.ASC_REQ_REPLAY_DETECT|sspicon.ASC_REQ_CONFIDENTIALITY|\
            sspicon.ASC_REQ_IDENTIFY)

    def AuthHandler(self,session,sasl,data):

        if not data:
            return 'challenge', None, None

        try:
            err, sec_buffer = self.sa.authorize(data)
        except sspi.error, details:
            print "FAILED to authorize client:", details
            return 'fail', None, 'not-authorized'

        if err==0:

            names = self.sa.ctxt.QueryContextAttributes(sspicon.SECPKG_ATTR_NAMES).lower().split('\\', 1)
            # This assumes all users are connecting to the right servername,
            #  we should rather put a domain/realm on each server and search for it.
            authzid = '%s@%s'%(names[1],session.ourname)

            if sec_buffer[0].BufferSize:
                return 'success', authzid, sec_buffer[0].Buffer
            else:
                return 'success', authzid, None

        return 'challenge', None, sec_buffer[0].Buffer

class SASL_SPNEGO(SASL_GSSAPI):
    mechanism = 'SPNEGO'
    package = 'Negotiate'

class SASL_NTLM(SASL_GSSAPI):
    mechanism = 'NTLM'
    package = 'NTLM'
