class SASL_PLAIN:
    mechanism = 'PLAIN'

    def AuthHandler(self,session,sasl,data):
        
        """The mechanism consists of a single message from the client to the
           server.  The client sends the authorization identity (identity to
           login as), followed by a NUL (U+0000) character, followed by the
           authentication identity (identity whose password will be used),
           followed by a NUL (U+0000) character, followed by the clear-text
           password."""
        pack=data.split('\000')
        authzid=session.peer
        if len(pack)<>3: res=0
        else:
            authzid, authcid, passwd = pack
            if not authzid:
                authzid=authcid
                if session.xmlns==NS_CLIENT: authzid+='@'+session.ourname
            username,domain=(authzid.split('@',1)+[''])[:2]
            res = ( passwd == sasl._owner.AUTH.getpassword(username, domain) )
        if res:
            result = 'success'
            extra = None
        else:
            result = 'fail'
            extra = 'not-authorized'

        return result, authzid, extra
